uses
  crt,
  dos;


const
  jumps    =[$01,$02,$03,$04];
  noupdates=[$01,$02,$03,$04,$1a];
  dests    =[$18,$19,$1a];
  havedests=[$03,$12,$80];

type
  ds_   =record
           opc  :array[0..3] of byte;
           lin  :longint;
           depth:word;
           typ  :byte;
           size :byte;
         end;
  sp_   =^ss;
  ss    =record
           start:longint;
           end_ :longint;
           depth:integer;
           next :sp_;
         end;
var
  tmode         :integer;
  f             :array[0..1] of file of ds_;
  fn            :array[0..1] of string;
  data          :array[0..1] of longint;
  sub           :array[0..1] of longint;
  call          :array[0..1] of longint;
  ret           :array[0..1] of longint;
  jump          :array[0..1] of longint;
  mindepth      :array[0..1] of longint;
  maxdepth      :array[0..1] of longint;
  mdv           :array[0..1] of longint;

  depth         :array[0..1] of longint;
  ds            :array[0..1] of ds_;

  cp            :array[0..1] of sp_;
  tp            :sp_;

  c             :byte;
  cw            :byte;
  fp            :array[0..1] of longint;

  ch,lch        :char;

  i             :byte;

const
  hs            :string[16]='0123456789ABCDEF';
  sp            :array[0..1] of sp_=(nil,nil);
  maxfile       :byte=0;

  ps            :array[0..1] of word=(0,0);

  read_         :boolean=false;

  check_jump    :boolean=false;
  synchron      :boolean=false;


  write_int     :boolean=true;
  write_jump    :boolean=true;
  write_dest    :boolean=true;
  write_opc     :boolean=true;


function act:boolean;
begin
  act:=(c=cw) or synchron;
end;

{*************************************************************************}
function  hexb(v:byte):string;
begin
  hexb:=hs[(v shr 4)+1]+hs[(v and $f)+1];
end;
function  hexw(v:word):string;
begin
  hexw:=hexb(hi(v))+hexb(lo(v));
end;
function  hexd(v:longint):string;
begin
  hexd:=hexw(v shr 16)+hexw(v and $ffff);
end;
{*************************************************************************}
{test if address in sub}
function  within(lin:longint;pt:sp_):boolean;
begin
  within:=false;
  if (pt^.start<=lin) and (pt^.end_>=lin) then
    within:=true;
end;

{create new sub}
procedure get_sub;
begin
  getmem(cp[c],sizeof(ds_));
  if sp[c]=NIL then
    sp[c]:=cp[c]
  else begin
    tp:=sp[c];
    while tp^.next<>NIL do tp:=tp^.next;
    tp^.next:=cp[c];
  end;
  cp[c]^.next:=NIL;
  cp[c]^.start:=0;
  cp[c]^.end_:=--1 shr 1;
  cp[c]^.depth:=depth[c];
  inc(sub[c]);
end;

{find sub with ds.lin within}
function  find_sub:word;
var
  w:word;
begin
  w:=0;
  cp[c]:=sp[c];
  while (cp[c]<>nil) and not within(ds[c].lin,cp[c]) do begin
    inc(w);
    cp[c]:=cp[c]^.next;
  end;
  if (cp[c]=nil) and read_ then get_sub;
  find_sub:=w;
end;

{update start and end address of current sub}
procedure update_sub;
begin
  if (not check_jump) and (ds[c].typ in noupdates) then exit;

  if cp[c]=NIL then find_sub;
  if (cp[c]^.start=0) or (cp[c]^.start>ds[c].lin) then
    cp[c]^.start:=ds[c].lin;
  if ds[c].typ=$80 then inc(ds[c].lin,ds[c].size);
  if (cp[c]^.end_=-1 shr 1) or (cp[c]^.end_<ds[c].lin) then
    cp[c]^.end_:=ds[c].lin;
end;

{test if current sub within another}
procedure check_sub;
var
  lp    :sp_;
  np    :sp_;
begin
  lp:=nil;
  tp:=sp[c];
  while tp<>nil do begin
    np:=tp^.next;
    if (tp<>cp[c]) and (within(cp[c]^.start,tp) or
                     within(cp[c]^.end_,tp) or
                     within(tp^.start,cp[c]) or
                     within(tp^.end_,cp[c])) then begin
      if cp[c]^.start>tp^.start then cp[c]^.start:=tp^.start;
      if cp[c]^.end_<tp^.end_ then cp[c]^.end_:=tp^.end_;
      if tp^.depth<cp[c]^.depth then cp[c]^.depth:=tp^.depth;

      if lp<>nil then lp^.next:=tp^.next else sp[c]:=tp^.next;
      freemem(tp,sizeof(ds_));
      dec(sub[c]);
    end else lp:=tp;
    tp:=np;
  end;
end;
{*************************************************************************}
{delete sub chains}
procedure del_chain;
var
  i     :byte;
  procedure del_chain_;
  begin
    cp[i]:=sp[i];
    while cp[i]<>nil do begin
      tp:=cp[i];
      cp[i]:=cp[i]^.next;
      freemem(tp,sizeof(ds_));
    end;
    sp[i]:=nil;
  end;

begin
  for i:=0 to maxfile do del_chain_;
end;
{get sub chains}
procedure get_chain;
var
  i     :byte;
  procedure get_chain_;
  begin
    c:=i;
    data[c]:=0;
    sub[c]:=0;
    call[c]:=0;
    ret[c]:=0;
    jump[c]:=0;
    depth[c]:=0;
    mindepth[c]:=0;
    maxdepth[c]:=0;
    mdv[c]:=-1;
    fp[c]:=0;

    cp[c]:=nil;

    seek(f[c],0);

    while not eof(f[c]) do begin
      read(f[i],ds[c]);
      if mdv[c]=-1 then mdv[c]:=ds[c].depth;
      inc(data[c]);
      gotoxy(1,c*25+1);
      write('record: ',data[c]:8,' sub: ',sub[c]:5,' call: ',call[c]:5,
            ' ret:',ret[c]:5,' jump:',jump[c]:5,' level:',depth[c]:5);
      update_sub;

      case ds[c].typ of
        1,2       :inc(jump[c]);
        $12       :begin
                     inc(ret[c]);
                     check_sub;
                     dec(depth[c]);
                     if mindepth[c]>depth[c] then mindepth[c]:=depth[c];
                     cp[c]:=nil;
                   end;
        $80       :begin
                     inc(call[c]);
                     if ds[c].depth<>1 then inc(depth[c]);
                     if maxdepth[c]<depth[c] then maxdepth[c]:=depth[c];
                     cp[c]:=nil;
                   end;
        $1b       :inc(call[c]);
      end;
    end;

    cp[c]:=sp[c];
    while cp[c]<>nil do begin
      cp[c]^.depth:=cp[c]^.depth-mindepth[c];
      cp[c]:=cp[c]^.next;
    end;
    seek(f[c],0);
    read(f[c],ds[c]);
  end;
begin
  del_chain;
  for i:=0 to maxfile do get_chain_;
  cw:=0;
  depth[0]:=-1;
  depth[1]:=-1;
end;
{*************************************************************************}
procedure write_win;
  procedure write_win_;
  var
    i   :byte;
  begin
    window(1,1,80,50);
    gotoxy(1,c*25+1);
    for i:=1 to 80 do if act then begin
      textcolor(white);
      write(#205)
    end else begin
      textcolor(darkgray);
      write(#196);
    end;
    gotoxy(4,c*25+1);
    write(' ',fn[c],' ');
    gotoxy(80-7-6-6,c*25+1);
    write(fp[c]:5,'/',data[c],' ',fp[c]/data[c]*100:5:1,'%');
  end;
begin
  for c:=0 to maxfile do write_win_;
  textcolor(yellow);
  gotoxy(40,1);
  if synchron then write('S') else write('s');
  if check_jump then write('J') else write('j');
  gotoxy(wherex+1,1);
  case lch of
    'A' :begin
           if write_jump then write('W') else write('w');
           if write_int then write('I') else write('i');
           if write_dest then write('D') else write('d');
           if write_opc then write('O') else write('o');
         end;
  end;
end;

function winl:byte;
begin
  if maxfile=0 then winl:=49 else winl:=24;
end;
function ignore:boolean;
begin
  ignore:=(ds[c].typ in dests) or
          ((not write_jump) and (ds[c].typ in jumps)) or
          ((not write_int) and (ds[c].typ=$81));
end;


procedure start_write;
begin
  write_win;
  window(1,1,80,50);
  seek(f[0],fp[0]);
  if maxfile=1 then seek(f[1],fp[1]);
  textcolor(lightgray);
end;

procedure write_analysis;
var
  cdepth:array [0..1] of longint;
procedure write_sub;
var
  jd    :byte;
  tx    :integer;
  pa    :byte;
begin
  if false and (cdepth[c]*3>80-6-9) then write(#175) else begin
    write(#13,hexd(ds[c].lin));
    if ds[c].typ=$12 then pa:=1 else pa:=0;

    gotoxy((pa+mdv[c]-ds[c].depth-mindepth[c])*3+11,wherey);
    write(copy(hexw(find_sub),2,3));

    case ds[c].typ of
      $80     :write('cal');
      $12     :write('ret');
      $1      :write('nj');
      $2      :write('j ');
      $3      :write('jmp');
      $81     :write('int');
      $4      :write('jmp/loop');
    end;

    case ds[c].typ of
      $1,$2   :begin
                 if ds[c].opc[0]=$f then jd:=ds[c].opc[3] else jd:=ds[c].opc[1];
                 if jd>$7f then write(#24) else write(#25);
               end;
    end;

    tx:=wherex;

    if not write_opc then exit;

    gotoxy(80-12,wherey);
    case ds[c].typ of
      $1,$2   :begin
                 case ds[c].opc[0] of
                   $70 :write('JO');
                   $71 :write('JNO');
                   $72 :write('JB');
                   $73 :write('JAE');
                   $74 :write('JE');
                   $75 :write('JNE');
                   $76 :write('JBE');
                   $77 :write('JA');
                   $78 :write('JS');
                   $79 :write('JNS');
                   $7a :write('JP');
                   $7b :write('JNP');
                   $7c :write('JL');
                   $7d :write('JGE');
                   $7e :write('JLE');
                   $7f :write('JG');
                 end;
               end;
      $3      :case ds[c].opc[0] of
                 $ea :write('jmpf adr');
                 $eb :write('jmp disp8');
                 $e9 :write('jmp disp16');
                 $ff :case (ds[c].opc[1] shr 3) and 7 of
                        $3   :write('jmpf mem');
                        $2   :write('jmpf m/r');
                      end;
               end;
      $4      :case ds[c].opc[0] of
                 $eb :write('jmp disp8');
                 $e2 :write('loop');
                 $e1 :write('loopz');
                 $e0 :write('loopnz');
               end;
      $80,$1b :case ds[c].opc[0] of
                 $9a :write('callf dir');
                 $e8 :write('call disp16');
                 $ff :case (ds[c].opc[1] shr 3) and 7 of
                        $3   :write('callf mem');
                        $2   :write('callf m/r');
                      end;
               end;
      $81     :case ds[c].opc[0] of
                 $cd :write('int ',hexb(ds[c].opc[1]));
                 $ce :write('into');
                 $cc :write('int03');
               end;
      $12     :case ds[c].opc[0] of
                 $cb :write('retn');
                 $c3 :write('retf');
                 $ca :write('retf disp16');
                 $c2 :write('retn disp16');
               end;
    end;
    gotoxy(tx,wherey);
  end;
end;
procedure get_dest;
begin
  if (ds[c].depth=1) or (eof(f[c])) then exit;
  read(f[c],ds[c]);
  if act and write_dest then begin
{    gotoxy(80-15,wherey);}
    write(' to ',hexd(ds[c].lin));
  end;
end;

var
  l     :byte;
begin
  start_write;
  for c:=0 to 1 do cdepth[c]:=depth[c];

  for l:=1 to winl do begin
    for c:=0 to 1 do
      if (maxfile>=c) and (not eof(f[c])) then begin
        read(f[c],ds[c]);
        while (not eof(f[c])) and
              ((ds[c].typ in dests) or
               ((not write_jump) and (ds[c].typ in jumps)) or
               ((not write_int) and (ds[c].typ=$81))) do
          read(f[c],ds[c]);
        if cdepth[c]=-1 then begin
          cdepth[c]:=mdv[c]-ds[c].depth-mindepth[c];
          if ds[c].typ=$12 then inc(cdepth[c]);
        end;
      end else
        ds[c].typ:=0;
    textcolor(yellow);
    if ((maxfile=1) and (ds[0].typ<>0) and (ds[1].typ<>0) and
       (ds[0].typ=ds[1].typ) and (ds[0].lin=ds[1].lin)) or
       (maxfile=0) then textcolor(lightgray);

    for c:=0 to maxfile do begin
      gotoxy(1,c*25+1+l);
      clreol;
      case ds[c].typ of
        $01,$02,
        $1b,$81,
        $03,$04   :write_sub;
        $12       :begin
                     write_sub;
                     dec(cdepth[c]);
                   end;
        $80       :begin
                     write_sub;
                     inc(cdepth[c]);
                   end;
      end;
      if ds[c].typ in havedests then get_dest;
      if (l=1) and act then depth[c]:=cdepth[c];
    end;
  end;
end;


procedure write_proc;
var
  l     :byte;
  i     :byte;
begin
  start_write;

  for i:=0 to maxfile do begin
    if ps[i]>sub[c] then ps[i]:=sub[c];
    cp[i]:=sp[i];
    for l:=1 to ps[i] do
      cp[i]:=cp[i]^.next;
  end;

  for l:=0 to winl-1 do
    for c:=0 to maxfile do begin
      gotoxy(1,l+2+c*25);
      clreol;
      if ps[c]+l<sub[c] then begin
        write(hexw(ps[c]+l+1),' ',hexd(cp[c]^.start),'-',
                            hexd(cp[c]^.end_),' level ',
                            hexw(cp[c]^.depth));
        cp[c]:=cp[c]^.next;
      end;
    end;
end;


procedure read_data;
var
  i     :byte;
begin
  read_:=true;
  get_chain;
  read_:=false;
end;

procedure help;
begin
  clrscr;
  write('F1  - this screen'#10#13,
        'F   - set file'#10#13,
        'R   - read data'#10#13,
        'J   - use/ignore intersub jumps'#10#13,
        'S   - toggle synchron mode'#10#13,
        'TAB - toggle screen'#10#13,
        'A   - analysis mode'#10#13,
        '      W   - toggle jumps'#10#13,
        '      O   - toggle opcodes'#10#13,
        '      D   - toggle destination address'#10#13,
        '      I   - toggle interrupts'#10#13,
        'P   - procedure mode'#10#13);

  readkey;
end;


procedure a_go_up;
begin
  for c:=0 to 1 do
    if act and (fp[c]>0) then begin
    dec(fp[c]);
    seek(f[c],fp[c]);
    read(f[c],ds[c]);
    while (fp[c]>0) and ignore do begin
      dec(fp[c]);
      seek(f[c],fp[c]);
      read(f[c],ds[c]);
    end;
  end;
end;

procedure a_go_down;
begin
  for c:=0 to 1 do
  if act and (fp[c]<data[c]) then begin
    inc(fp[c]);
    seek(f[c],fp[c]);
    read(f[c],ds[c]);
    while (fp[c]<data[c]) and ignore do begin
      inc(fp[c]);
      seek(f[c],fp[c]);
      read(f[c],ds[c]);
    end;
  end;
end;

begin
tmode:=lastmode;
textmode($103);
fn[0]:='t.ps1';
fn[1]:='\r2';

assign(f[0],fn[0]);
reset(f[0]);
assign(f[1],fn[1]);
reset(f[1]);
maxfile:=1;

ch:='R';
lch:='A';
repeat
  case ch of
    'R'   :begin
             read_data;
             write_analysis;
           end;
    'A'   :begin
             lch:='A';
             write_analysis;
           end;

    'P'   :begin
             lch:='P';
             write_proc;
           end;
    'J'   :begin
             check_jump:=not check_jump;
             read_data;
           end;
    'S'   :begin
             synchron:=not synchron and (maxfile=1);
             write_win;
           end;
    #9    :if not synchron then begin
             cw:=(cw xor 1) and maxfile;
             write_win;
           end;
    #0    :case lch of
           'A'  :case readkey of
                   ';' :help;
                   'H' :a_go_up;
                   'P' :a_go_down;
                   'G' :for c:=0 to 1 do if act then fp[c]:=0;
                   'I' :for i:=1 to winl do
                          a_go_up;
                   'Q' :for i:=1 to winl do
                          a_go_down;
                 end;
           'P'  :case readkey of
                   ';' :help;
                   'H' :for c:=0 to 1 do
                          if act and (ps[c]>0) then dec(ps[c]);
                   'P' :for c:=0 to 1 do
                          if act and (ps[c]<sub[c]-1) then inc(ps[c]);
                   'G' :for c:=0 to 1 do if act then ps[c]:=0;
                 end;
           end;
    else case lch of
           'A'  :case ch of
                   'W'   :write_jump:=not write_jump;
                   'D'   :write_dest:=not write_dest;
                   'O'   :write_opc:=not write_opc;
                   'I'   :write_int:=not write_int;
                 end;
         end;
  end;
  if ch in [#9,'S','W','D','O',#0,'R','J','I'] then
    ch:=lch
  else
    ch:=upcase(readkey);
until ch=#27;
textmode(tmode);
end.